{{ansible_managed|comment}}

# Basic configuration
# ===================

# Configure hostkeys in the order we wish to offer them
HostKey /etc/ssh/ssh_host_ed25519_key
#HostKey /etc/ssh/ssh_host_rsa_key
#HostKey /etc/ssh/ssh_host_ecdsa_key

# Specifies the host key algorithms that the server offers.
HostKeyAlgorithms ssh-ed25519,ssh-ed25519-cert-v01@openssh.com,sk-ssh-ed25519@openssh.com,sk-ssh-ed25519-cert-v01@openssh.com

# Security configuration
# ======================

# Set the protocol version to 2 for security reasons. Disables legacy support.
Protocol 2

# Make sure sshd checks file modes and ownership before accepting logins. This prevents accidental misconfiguration.
StrictModes yes

# Logging, obsoletes QuietMode and FascistLogging
SyslogFacility {{ sshd_syslog_facility }}
LogLevel {{ sshd_log_level }}

# CIS 5.2.8 Ensure SSH root login is disabled
PermitRootLogin no

# CIS 5.2.10 Ensure SSH PermitUserEnvironment is disabled
PermitUserEnvironment no

# Cryptography
# ------------

KexAlgorithms curve25519-sha256@libssh.org,diffie-hellman-group-exchange-sha256,diffie-hellman-group18-sha512
Ciphers chacha20-poly1305@openssh.com,aes256-gcm@openssh.com,aes128-gcm@openssh.com,aes256-ctr,aes192-ctr,aes128-ctr
MACs hmac-sha2-512-etm@openssh.com,hmac-sha2-256-etm@openssh.com,umac-128-etm@openssh.com

# Authentication
# --------------

LoginGraceTime 30
MaxAuthTries 5
MaxSessions 10
MaxStartups 10:30:100

# Enable public key authentication
PubkeyAuthentication yes

# Never use host-based authentication. It can be exploited.
IgnoreRhosts yes
IgnoreUserKnownHosts yes
HostbasedAuthentication no

UsePAM yes

# Set AuthenticationMethods per default to publickey
AuthenticationMethods publickey

# Disable password-based authentication, it can allow for potentially easier brute-force attacks
PasswordAuthentication no
PermitEmptyPasswords no
ChallengeResponseAuthentication no

# Only enable GSSAPI authentication if it is configured.
GSSAPIAuthentication no

# Network
# -------

# Disable TCP keep alive since it is spoofable. Use ClientAlive messages instead, they use the encrypted channel
TCPKeepAlive no

# Manage `ClientAlive..` signals via interval and maximum count. This will periodically check up to a `..CountMax` number of times within `..Interval` timeframe, and abort the connection once these fail.
# CIS 5.2.12 Ensure SSH Idle Timeout Interval is configured
ClientAliveInterval 120
ClientAliveCountMax 3

# Permit tunneling
PermitTunnel yes

# Allow forwarding tcp connections.
# no real advantage without denied shell access
AllowTcpForwarding yes

# Allow agent forwarding, since local agent could be accessed through forwarded connection.
# no real advantage without denied shell access
AllowAgentForwarding yes

# Do not allow remote port forwardings to bind to non-loopback addresses.
GatewayPorts no

# Disable X11 forwarding, since local X11 display could be accessed through forwarded connection.
X11Forwarding no
X11UseLocalhost yes

# User environment configuration
# ==============================

PermitUserEnvironment no

# Misc. configuration
# ===================

Compression no
UseDNS no
PrintMotd no
PrintLastLog yes
Banner /etc/issue.net
